define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var SqliteUtil = require("$UI/demo/sqlite_1/sqliteUtil");
	var DemoDB = require("$UI/demo/sqlite_1/demoDB");

	var Model = function() {
		this.callParent();
		this.demoDB = null;
	};
	Model.prototype.testFilterType = function(row) {
		return row.val('fc_id') == 2;
	}
	Model.prototype.modelLoad = function(event) {
		var self = this;
		self.demoDB = DemoDB.getInstance();
		self.demoDB.initData(function() {
			self.comp("list1").refresh(true);
		});
	};
	Model.prototype.deleteBtnClick = function(event) {
		var row = event.bindingContext.$object;// bindingObjects
		$(this.getElementByXid("label1")).text(row.val("ftype"));
	};

	Model.prototype.button2Click = function(event) {//下一行
		var col = $(this.getElementByXid("label1")).text();
		var rows = this.comp("list1").getBindingObjects();
		var t = 0;
		$.each(rows, function(i, row) {
			t = i;
			if (row.val('ftype') == col) {
				return false;
			}
		});   
		if (t + 1 != rows.length) {
			$(this.getElementByXid("label1")).text(rows[t + 1].val("ftype"));
		} else {
			debugger;
			this.comp("data1").loadNextPageData();
			this.button2Click();
		}
	};
	Model.prototype.data1CustomRefresh = function(event) {
		event.async = true;
		var db = this.demoDB.getDatabase();
		var data = event.source;
		var append = event.options && event.options.append; // 是否数据追加模式
		var limit = event.limit; // 分页行数
		var offset = event.offset; // 分页偏移
		SqliteUtil.executeSql(db, "SELECT * FROM demo_region LIMIT ? OFFSET ? ", [ limit, offset ], onSuccess, onError);
		function onSuccess(res) {
			var table = SqliteUtil.rowsToTable(res.rows);
			if (offset == 0) {
				// 如果偏移为零则表明加载第一页，需要在Table中提供总行数，用于分页计算
				SqliteUtil.executeSql(db, "SELECT COUNT(*) cnt FROM demo_region ", [], function(res) {
					SqliteUtil.setTableTotal(table, res.rows.item(0).cnt);
					doRefreshData();
				});
			} else {
				doRefreshData();
			}
			function doRefreshData() {
				data.loadData(table, append);
				// 异步执行模式下，加载数据后必须执行doRefreshAfter
				data.doRefreshAfter(true, event.options);
			}
		}
		function onError(msg) {
			data.doRefreshAfter(false, event.options);
		}
	};
	Model.prototype.data1AfterRefresh = function(event) {
		var data = this.comp("data1");
		$(this.getElementByXid("label1")).text(data.getValue("ftype"));
	};

	return Model;
});